/*  Pcsx - Pc Psx Emulator
 *  Copyright (C) 1999-2002  Pcsx Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __MEMORY_H__
#define __MEMORY_H__

char *RAM;
#define RAM8(mem)	RAM[(mem) & 0x1fffff]
#define RAM16(mem)	(*(short*)&RAM[(mem) & 0x1fffff])
#define RAM32(mem)	(*(long*) &RAM[(mem) & 0x1fffff])
#define uRAM8(mem)	(*(unsigned char*) &RAM[(mem) & 0x1fffff])
#define uRAM16(mem)	(*(unsigned short*)&RAM[(mem) & 0x1fffff])
#define uRAM32(mem)	(*(unsigned long*) &RAM[(mem) & 0x1fffff])

char *PPM;
#define PPM8(mem)	PPM[(mem) & 0xffff]
#define PPM16(mem)	(*(short*)&PPM[(mem) & 0xffff])
#define PPM32(mem)	(*(long*) &PPM[(mem) & 0xffff])
#define uPPM8(mem)	(*(unsigned char*) &PPM[(mem) & 0xffff])
#define uPPM16(mem)	(*(unsigned short*)&PPM[(mem) & 0xffff])
#define uPPM32(mem)	(*(unsigned long*) &PPM[(mem) & 0xffff])

char *ROM;
#define ROM8(mem)	ROM[(mem) & 0x7ffff]
#define ROM16(mem)	(*(short*)&ROM[(mem) & 0x7ffff])
#define ROM32(mem)	(*(long*) &ROM[(mem) & 0x7ffff])
#define uROM8(mem)	(*(unsigned char*) &ROM[(mem) & 0x7ffff])
#define uROM16(mem)	(*(unsigned short*)&ROM[(mem) & 0x7ffff])
#define uROM32(mem)	(*(unsigned long*) &ROM[(mem) & 0x7ffff])

char *HWM;
#define HWM8(mem)	HWM[(mem) & 0xffff]
#define HWM16(mem)	(*(short*)&HWM[(mem) & 0xffff])
#define HWM32(mem)	(*(long*) &HWM[(mem) & 0xffff])
#define uHWM8(mem)	(*(unsigned char*) &HWM[(mem) & 0xffff])
#define uHWM16(mem)	(*(unsigned short*)&HWM[(mem) & 0xffff])
#define uHWM32(mem)	(*(unsigned long*) &HWM[(mem) & 0xffff])

long *memLUT;

int  memInit();
void memReset();
void memShutdown();

unsigned char  memRead8 (unsigned long mem);
unsigned short memRead16(unsigned long mem);
unsigned long  memRead32(unsigned long mem);
void memWrite8 (unsigned long mem, unsigned char value);
void memWrite16(unsigned long mem, unsigned short value);
void memWrite32(unsigned long mem, unsigned long value);

#endif /* __MEMORY_H__ */
